#include <stdio.h>
#include <math.h>

#include "vector.h"

/** @brief 
 *  An exemple of mathematical function 
 *  in 1 dimension.
 * 
 *  @param x A double variable.
 *  @return f(x) = 2.0*sin(x) - 3.0*cos(x)
 */
double my_function(double x)
{
    return 2.0 * sin(x) - 3.0 * cos(x);
}

int main()
{
    // Create a vector X = [0,1,2...99]
    double_vector_t *X = iota(100);
    // Create a vector Y = my_function(x)
    double_vector_t *Y = apply_function(X, my_function);

    // Export our vectors into files
    export_vector("../X.vec", X);
    export_vector("../Y.vec", Y);

    // Free our vectors
    destroy_vector(&Y);
    destroy_vector(&X);
}